using Entidades;

namespace Modelo
{
    public sealed class RepositorioProveedor : RepositorioBase<Proveedor, RepositorioProveedor>
    {
        override public bool Add(Proveedor t)
        {
            if (ExistePorCuit(t.Cuit))
            {
                throw new InvalidOperationException($"El Proveedor con el CUIT {t.Cuit} ya existe.");
            }

            try
            {
                almacen.Add(t);
                return true;
            }
            catch (Exception)
            {
                throw;
            }
        }

        override public bool Mod(Proveedor t)
        {
            bool ret = false;

            try
            {
                var proveedorAModificar = almacen.FindIndex(x => x.Cuit == t.Cuit);
                if (proveedorAModificar > -1)
                {
                    almacen[proveedorAModificar] = t;
                    ret = true;
                }
            }
            catch (Exception)
            {
                throw;
            }

            return ret;
        }

        override public bool Del(Proveedor t)
        {
            bool ret = false;

            try
            {
                var proveedorAEliminar = almacen.Find(x => x.Cuit == t.Cuit);
                if (proveedorAEliminar != null)
                {
                    proveedorAEliminar.Habilitado = false;
                    ret = true;
                }
            }
            catch (Exception)
            {
                throw;
            }

            return ret;
        }

        public bool ExistePorCuit(long cuit)
        {
            return almacen.Any(p => p.Cuit == cuit);
        }
    }
}
